CON

  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

  'Parallax Serial Terminal Control Character Constants
  HM =  1 'HM: Home Cursor       
  PC =  2 'PC: Position Cursor In X, Y
  ML =  3 'ML: Move Cursor Left          
  MR =  4 'MR: Move Cursor Right         
  MU =  5 'MU: Move Cursor Up          
  MD =  6 'MD: Move Cursor Down
  BP =  7 'BP: Beep Speaker
  BS =  8 'BS: Backspace
  TB =  9 'TB: Tab
  LF = 10 'LF: Line Feed
  CE = 11 'CE: Clear To End Of line     
  CB = 12 'CB: Clear Lines Below
  CR = 13 'CR: Carriage Return          
  PX = 14 'PX: Position Cursor In X         
  PY = 15 'PY: Position Cursor In Y
  CS = 16 'CS: Clear Screen
  SP = 32 'Space

VAR

  LONG DataField1
  LONG DataField2

OBJ

  Serial : "FullDuplexSerial"
  Master : "InterComm"
  Slave : "InterComm"

PUB Main

  Serial.Start(31, 30, 0, 115_200)  

  WAITCNT(CLKFREQ * 2 + CNT)

  Serial.Tx(CS)
  Serial.Rxflush

  Serial.Str(STRING("InterComm Demo"))
  Serial.Tx(CR)

  IF Master.Start(0, 1, 0, 19200)

    Serial.Str(STRING("Master Started"))

  ELSE
    Serial.Str(STRING("Master Failed"))

  Serial.Tx(CR)

  IF Slave.Start(1, 0, 0, 19200)

    Serial.Str(STRING("Slave Started"))

  ELSE

    Serial.Str(STRING("Slave Failed"))

  Serial.Tx(CR)

  WAITCNT(CLKFREQ * 6 + CNT)

  Master.UpdateTxString(STRING("2147483643:2147483647"))

  REPEAT WHILE Slave.IsNewDataAvailable == FALSE
  
  WAITCNT(CLKFREQ * 2 + CNT)

  IF Slave.IsNewDataAvailable == TRUE

    Serial.Str(STRING("New data should be available"))

  ELSE

    Serial.Str(STRING("New data is unavailable"))

'  DataField1 := 0
'  DataField2 := 0  
  Slave.GetDataFields(@DataField1, @DataField2)  

  Serial.Tx(CR)
  Serial.Dec(DataField1)
  Serial.Tx(CR)
  Serial.Dec(DataField2)

  